#include <TM1637.h> //подключаем библиотеку для работы индикатора
#include <EEPROM.h> //подключаем библиотеку для работы с энергонезависимой памятью
#define CLK 5 
#define DIO 4
TM1637 disp(CLK,DIO);//уставливаем выходы CLK,DIO для цифрового индикатора
int a_pin_1=A7; //аналоговый вход с фоторезистора
int d_pin_1=2; //цифровой вход кнопки 1
int d_pin_2=3; //цифровой вход кнопки 2
int res=0; //переменная значения фоторезистора 0-1023
int people; // переменная счетчик прошедших людей 
int reset=0;// переменная значения кнопки 1 (кнопка сброса)
int pass_reset=0; //переменная значения кнопки 2 (ввод пароля сброса)
int pass=0; //переменная значения введенного пароля
bool g; //переменная переключатель режимов работы (счет или сброс)
byte hi; //переменные для записи большо числа по битам
byte low;
int maxi=0; // максимальное значение переменной в EEPROM
int address=0; //адрес в памяти EEPROM

void setup() 
{
disp.set(5);
disp.init(D4056A); 
pinMode(d_pin_1,INPUT); 
pinMode(d_pin_2,INPUT);

for (int addr=0; addr<EEPROM.length(); addr=addr+2)//ищем последнюю запись в EEPROM, т.е самое большое значение
{ 
 hi = EEPROM.read(addr);//берем по две ячейки памяти и собираем число
 low = EEPROM.read(addr+1);
 int val = word(hi, low);
 if (val>maxi)//переменная maxi получит значение последней записи.
 {
  maxi=val;
 }
}
people=maxi;
disp.display(people); //выводим на индикатор последнее число в памяти
}

void loop() 
{
 if(people<10000)//счет будет вестить до 9999 
 {
//проверяем не нажата ли кнопка 1 (сброса) 
reset=digitalRead(d_pin_1);
if(reset==1)//если да то
{
  
  g=true;//переключаемся в режим сброса, счет данных прекращен, получаем значение пароля сброса
  if(pass==7)//по умолчанию пароль сброса равен 7, если пароль правильный, то
  {
  g=false; //переключаем режим в работу счета
  people=0;//очищаем счетчик
  pass=0;//очищаем пароль
  for (int i = 0 ; i < EEPROM.length() ; i++) {
  EEPROM.write(i, 0);//обнуляем память EEPROM
  }
  disp.display(people);
  }
  else //если пароль не правильный
  {
    if(pass>0)
    {
  g=false; //переключаемся в режим счета
  disp.display(people);// счет продолжается выводим на дисплей последнее число
  pass=0;//обнуляем пароль
    }
  }
}
//режим счета
if(g==false)
{

res=analogRead(a_pin_1);//получаем значение с фоторезистора
if(res>50)//луч лазера перекрыт
{
delay(500);//ждем 500 млс 
res=analogRead(a_pin_1);//снова получаем значение с фоторезистора
if(res<50)//луч лазера снова светит, кто то прошел
{
people+=1;//прибавляем значение к счетчику 
disp.display(people);//выводим значение на индикатор
pass=0;
hi = highByte(people);
low = lowByte(people);
EEPROM.write(address, hi); 
EEPROM.write((address+1), low);//разбиваем число по байтам и записываем в память
address = address + 2;//замена адреса ячеек для следующих значений
if (address == EEPROM.length()) 
{
    address = 0;//обнуление адреса ячеек при достижении конца
}

}
} 
}
//ввод пароля с кнопки 2
if(g==true)//режим ввода пароля
{
pass_reset=digitalRead(d_pin_2);//получаем значение цифровое значение с кнопки 2
if(pass_reset==1)// кнопка сброса пароля нажата
{
delay(200);//скорость среднего нажатия кнопки человеком
pass+=1;
disp.display(pass);//показываем вводимый пароль
}
}
}
}

